package com.ga3w20.validation;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
 *
 * @author Yongchao
 */
public class HashUtil {
    
    private final static Logger LOG = LoggerFactory.getLogger(HashUtil.class);
    
    /**
     * @author Yongchao
     * @param passwordToHash a string of password is used to generate HASH
     * @param salt a byte array is used to to generate HASH
     * @return HASH value generated by SHA-256 
     */
    public String getHash(String passwordToHash, byte[] salt)
    {
        String generatedPassword = null;
        try {
            MessageDigest md = MessageDigest.getInstance("SHA-256");
            md.update(salt);
            byte[] bytes = md.digest(passwordToHash.getBytes());
            StringBuilder sb = new StringBuilder();
            for(int i=0; i< bytes.length ;i++)
            {
                sb.append(Integer.toString((bytes[i] & 0xff) + 0x100, 16).substring(1));
            }
            generatedPassword = sb.toString();
        } 
        catch (NoSuchAlgorithmException e) 
        {
            LOG.error("No SHA-256 Algorithm.");
        }
        return generatedPassword;
    }    
    /**
     * @author Yongchao
     * @return a byte array used as a salt to generate HASH value.     
     */
    public byte[] getSalt() {
        byte[] salt = new byte[16];
        try {
            SecureRandom sr = SecureRandom.getInstance("SHA1PRNG");
            sr.nextBytes(salt);
        } 
        catch (NoSuchAlgorithmException e) 
        {
            LOG.error("No SecureRandom.");
        }
        return salt;
    }
}
